;;; $Id: tps.scm,v 1.24 1996/09/25 10:49:30 queinnec Exp $
;;; Ce fichier contient les solutions des exercices poses en TP.

;;; A tout seigneur, tout honneur:
(define (factorielle nombre)
  (if (= nombre 1)
      1
      (* nombre (factorielle (- nombre 1))) ) )

(define poeme-pi
  '(q u e j a i m e a f a i r e a p p r e
      n d r e u n n o m b r e u t i l e a u s a g e ) )

;;; compter au premier niveau.
(define (compter mot phrase)
  (if (pair? phrase)
      (+ (if (equal? mot (car phrase)) 1 0) ; Notez l'alternative sous l'addition!
         (compter mot (cdr phrase)) )
      0 ) )

;;; compter a tous les niveaux.
(define (decompter feuille arbre)
  (if (pair? arbre)
      (+ (decompter feuille (car arbre))   ; r\'ecursion \`a gauche
         (decompter feuille (cdr arbre)) ) ; r\'ecursion \`a droite
      (if (equal? feuille arbre)
          1
          0 ) ) )

(define (begaie phrase)
  (if (pair? phrase)                    ; si la phrase a au moins un mot
      (cons (car phrase)                ; le r\'ep\'eter une fois
            (cons (car phrase)          ; le r\'ep\'eter deux fois~!
                  (begaie (cdr phrase)) ) )
      '() ) )

(define (debegaie phrase)
  (if (pair? phrase)
      (if (pair? (cdr phrase))
          (if (equal? (car phrase)      ; si le premier mot
                      (cadr phrase) )   ; est \'egal au second
              (debegaie (cdr phrase))
              (cons (car phrase) (debegaie (cdr phrase))) )
          phrase )
      phrase ) )

;;; impairs est une vraie inverse de begaie.
(define (impairs liste)
  (if (pair? liste)
      (cons (car liste) (pairs (cdr liste)))
      '() ) )
(define (pairs liste)
  (if (pair? liste)
      (impairs (cdr liste))
      '() ) )

(define (aplatir sexp)
  (if (pair? sexp)
      (append (aplatir (car sexp))    ;\ {\tt append} co\^uteux ici
              (aplatir (cdr sexp)) )
      (if (symbol? sexp)
          (list sexp)
          '() ) ) )

;;; Du numerique enfin !
(define (somme-carres n)
  (if (= n 0)
      0
      (+ (* n n) (somme-carres (- n 1))) ) )

;;; Piqu\'ee \`a Anne Valibouze, Nguyen Van Lu et d'autres. Elle
;;; s'appelait snoc alors.

(define (reconstruire exp)
  (if (pair? exp)
      (list 'cons (reconstruire (car exp))
                  (reconstruire (cdr exp)) )
      (list 'quote exp) ) )

;;; Premier exemple de sous-fonction locale.
(define (facteurs-premiers n)
  (define (fp n essai)
    (if (> n 1)
        (if (= 0 (remainder n essai))
            (cons essai (fp (quotient n essai) essai))
            (fp n (+ 1 essai)) )
        '() ) )
  (if (= n 1) (list 1) (fp n 2)) )

;;; TP 2

;;; premier emploi des connecteurs booleens.
(define (apparait-dans mot liste)
  (and (pair? liste)
       (or (equal? (car liste) mot)
           (apparait-dans mot (cdr liste)) ) ) )

;;; Cette version donne des resultats qui comportent des doublons.
(define (doublons1 liste)
  (define (parcourir liste deja-vus) ;\ {\tt deja-vus} est une variable tampon
    (if (pair? liste)
        (if (apparait-dans (car liste) deja-vus)
            (cons (car liste) (parcourir (cdr liste) deja-vus))
            (parcourir (cdr liste) (cons (car liste) deja-vus)) )
        '() ) )
  (parcourir liste '()) )

;;; Une autre version 
(define (doublons liste)
  (if (pair? liste)
      (if (member (car liste) (cdr liste))
          (cons (car liste) (doublons (cdr liste)))
          (doublons (cdr liste)) )
      '() ) )

(define (retirer element liste)
  (if (pair? liste)
      (if (equal? element (car liste))
          (cdr liste)
          (cons (car liste) (retirer element (cdr liste))) )
      '() ) )

(define (retirer-tous element liste)
  (if (pair? liste)
      (if (equal? element (car liste))
          (retirer-tous element (cdr liste)) ; continuer l'enl\`evement.
          (cons (car liste) (retirer-tous element (cdr liste))) )
      '() ) )

(define (stricts-doublons liste)
  (define (parcourir liste deja-vus doublons trop-vus)
    (if (pair? liste)
        (cond ((member (car liste) trop-vus)
               (parcourir (cdr liste) deja-vus doublons trop-vus) )
              ((member (car liste) doublons)
               (parcourir (cdr liste) deja-vus 
                          (retirer (car liste) doublons)
                          (cons (car liste) trop-vus) ) )
              ((member (car liste) deja-vus)
               (parcourir (cdr liste) deja-vus 
                           (cons (car liste) doublons) trop-vus ) )
              (else
               (parcourir (cdr liste) (cons (car liste) deja-vus) 
                          doublons trop-vus ) ) )
        doublons ) )
  (parcourir liste '() '() '()) )

(define (ajouter liste1 liste2)
  (if (pair? liste1)
      (cons (car liste1) (ajouter (cdr liste1) liste2))
      liste2 ) )

(define (stricts-doublons2 liste)
  (if (pair? liste)
      (let ((segment (member (car liste) (cdr liste))))
        (if segment
            (if (member (car liste) (cdr segment))
                (stricts-doublons2 (retirer-tous (car liste) (cdr liste)))
                (cons (car liste) (stricts-doublons2 (cdr liste))) )
            (stricts-doublons2 (cdr liste)) ) )
      '() ) )

(define (set-equal? set1 set2)
  (define (set-included? set1 set2)
    (if (pair? set1)
        (and (member (car set1) set2)
             (set-included? (cdr set1) set2) )
        #t ) )
  (and (set-included? set1 set2)
       (set-included? set2 set1) ) )

;;; Style par continuation
(define (extraire-stricts-doublons arbre)
  (define (parcourir arbre deja-vus doublons trop-vus suite)
    (if (pair? arbre)
        (parcourir (car arbre) 
                   deja-vus
                   doublons
                   trop-vus
                   (lambda (deja-vus doublons trop-vus)
                     (parcourir (cdr arbre)
                                deja-vus
                                doublons
                                trop-vus
                                suite ) ) )
        (if (member arbre deja-vus)
            (if (member arbre trop-vus)
                (suite deja-vus doublons trop-vus)
                (if (member arbre doublons)
                    (suite deja-vus (retirer arbre doublons) 
                           (cons arbre trop-vus) )
                    (suite deja-vus (cons arbre doublons) trop-vus) ) )
            (suite (cons arbre deja-vus) doublons trop-vus) ) ) )
  (parcourir arbre '() '() '() (lambda (deja-vus doublons trop-vus) 
                                 doublons )) )

;;; mais on peut aussi aplatir d'abord l'arbre
(define (extraire-stricts-doublons2 arbre)
  (stricts-doublons (aplatir arbre)) )

(define (aplatir2 e)
  (define (aplatir-interne e r)
    (if (pair? e)
        (aplatir-interne (car e) (aplatir-interne (cdr e) r))
        (if (null? e) r (cons e r)) ) )
  (aplatir-interne e '()) )

;;; plus connue sous le nom de reverse.

(define (renverser liste)
  (define (rev liste resultat)
    (if (pair? liste)
        (rev (cdr liste) (cons (car liste) resultat))
        resultat ) )
  (rev liste '()) )

(define (xpl liste)
  (define (map-on-all-cdr fonction liste)
    (if (pair? liste)
        (cons (fonction liste)
              (map-on-all-cdr fonction (cdr liste)) )
        '() ) )
  (reverse (map-on-all-cdr reverse (reverse liste))) )

(define (xpl1 l)
  (define (xpl2 l l1)
    (if (null? l) l1
        (xpl2 (cdr l) (map (lambda (u) (cons (car l) u)) (cons '() l1)))))
  (xpl2 (reverse l) '()))

(define (reduce fonction neutre liste)
  (if (pair? liste)
      (fonction (car liste) (reduce fonction neutre (cdr liste)))
      neutre ) )

(define (map-car fonction liste)
  (reduce (lambda (x r) (cons (fonction x) r)) '() liste) )

(define (iota debut fin)
  (if (< debut fin)
      (cons debut (iota (+ debut 1) fin))
      '() ) )

(define (fact-orielle n)
  (reduce * 1 (map-car (lambda (n) (+ n 1))
                       (iota 0 n) )) )

;;; Premiers exemples de filtrage

;;; filtre ::= ( { atome | ?- } . filtre )
(define (filtrer1 expression filtre)
  (if (pair? filtre)
      (and (pair? expression)
           (if (equal? (car filtre) '?-)
               (filtrer1 (cdr expression) (cdr filtre))
               (and (equal? (car expression) (car filtre))
                    (filtrer1 (cdr expression) (cdr filtre)) ) ) )
      (null? expression) ) )

;;; filtre ::= ( { atome | ?- | ... } . filtre )
(define (filtrer2 expression filtre)
  (if (pair? filtre)
      (cond ((equal? (car filtre) '?-)
             (and (pair? expression)
                  (filtrer2 (cdr expression) (cdr filtre)) ) )
            ((equal? (car filtre) '...)
             (or (filtrer2 expression (cdr filtre))
                 (and (pair? expression)
                      (filtrer2 (cdr expression) filtre) ) ) )
            (else
             (and (pair? expression)
                  (equal? (car expression) (car filtre))
                  (filtrer2 (cdr expression) (cdr filtre)) ) ) )
      (null? expression) ) )

;;; filtre ::= { atome | ?- | ... } | ( filtre . filtre )
(define (filtrer3 expression filtre)
  (define (filtrer3-liste expressions filtres)
    (if (pair? filtres)
        (if (equal? (car filtres) '...)
            (or (filtrer3-liste expressions (cdr filtres))
                (and (pair? expressions)
                     (filtrer3-liste (cdr expressions) filtres) ) )
            (and (pair? expressions)
                 (filtrer3 (car expressions) (car filtres))
                 (filtrer3-liste (cdr expressions) (cdr filtres)) ) )
        (equal? expressions filtres) ) )
  (or (equal? filtre '?-) 
      (if (equal? filtre '...)
          (error 'filtrer3 "... ne peut survenir ici")
          (if (pair? filtre) 
              (filtrer3-liste expression filtre)
              (equal? expression filtre) ) ) ) )

(define (filtrer3-curryfiee filtre)
  (lambda (expression)
    (filtrer3 expression filtre) ) )

;;; Curryfier sur le filtre par rapport a l'expression
(define (transformer-filtre5 filtre)
  (define (transformer-liste filtres)
    (if (pair? filtres)
        (if (equal? (car filtres) '...)
            (let ((filtre-cdr (transformer-liste (cdr filtres))))
              (letrec ((filtre
                        (lambda (expressions)
                          (or (filtre-cdr expressions)
                              (and (pair? expressions)
                                   (filtre (cdr expressions)) ) ) ) ) )
                filtre ) )
            (let ((filtre-car (transformer-filtre5 (car filtres)))
                  (filtre-cdr (transformer-filtre5 (cdr filtres))) )
              ;; Notez que filtre-car/cdr sont calcul\'es en dehors de ce qui suit.
              (lambda (expressions)
                (and (pair? expressions)
                     (filtre-car (car expressions))
                     (filtre-cdr (cdr expressions)) ) ) ) )
        (lambda (expressions) (equal? expressions filtres)) ) )
  (if (equal? filtre '?-)
      (lambda (expression) #t)
      (if (equal? filtre '...)
          (lambda (expression) 
            (error 'transformer-filtre5 "... ne peut survenir ici") )
          (if (pair? filtre)
              (transformer-liste filtre)
              (lambda (expression) (equal? filtre expression)) ) ) ) )

;;; A-listes fonctionnelles
(define (null-A-liste)
  (lambda (element) #f) )

(define (extend-A-liste al clef valeur)
  (lambda (element)
    (if (equal? clef element) 
        valeur
        (al element) ) ) )

(define (compose f g)
  (lambda (x) (g (f x))) )

(define (ncompose f g)
  (lambda arguments
    (g (apply f arguments)) ) )

(define (compose-n . fns)
  (lambda (x)
    ((reduce compose (lambda (x) x) fns) x) ) )

(define pi 3.1415926535)

(define (faire-sinus nombre)
  (let ((pas (/ pi (* 2 nombre)))
        (table (make-vector (+ nombre 1) 0.0)) )
    (do ((i 0 (+ 1 i)))
        ((>= i nombre) (vector-set! table nombre 1.0))
      (vector-set! table i (sin (* pas i))) )
    (lambda (x)
      (vector-ref table (inexact->exact (floor (/ x pas)))) ) ) )

(define (discretiser fonction debut fin nombre)
  (let ((pas   (/ (- fin debut) nombre))
        (table (make-vector (+ nombre 1) 0.0)) )
    (do ((i 0 (+ 1 i)))
        ((>= i nombre))
      (vector-set! table i (fonction (+ debut (* pas i)))) )
    (vector-set! table nombre (fonction fin))
    (lambda (x)
      (vector-ref table (inexact->exact (floor (/ (- x debut) pas)))) ) ) )

(define (discretiser2 fonction debut fin erreur)
  (let essayer ((nombre-de-pas 2))
    (let ((df  (discretiser fonction debut fin nombre-de-pas))
          (pas (/ (- fin debut) nombre-de-pas)) )
      (define (verifier-erreur i fi)
        (or (>= i fin)
            (let* ((i+1  (+ i pas))
                   (fi+1 (df i+1)) )
              (and (<= (abs (- fi+1 fi)) erreur)
                   (verifier-erreur i+1 fi+1) ) ) ) )
      (if (verifier-erreur debut (df debut))
          df
          (essayer (+ nombre-de-pas 1)) ) ) ) )

(define (faire-sinus-avec-discretiser nombre)
  (discretiser sin 0 (/ pi 2) nombre) )

(define (faire-sinus-avec-discretiser2 erreur)
  (discretiser2 sin 0 (/ pi 2) erreur) )

(define (etendre fonction debut fin)
  (let* ((empan (- fin debut))
         (deux-empans (* 2 empan))
         (milieu (+ fin empan)) )
    (lambda (x)
      (if (< x milieu)
          (if (< x fin) 
              (fonction x) 
              (fonction (- milieu x)) )
          (if (< x (+ milieu empan))
              (- (fonction (- x milieu)))
              (- (fonction (- (+ milieu deux-empans) x))) ) ) ) ) )

(define (iterer fonction debut fin)
  (let ((empan (- fin debut)))
    (lambda (x)
      (let* ((f (/ (- x debut) empan))
             (r (- (- x debut) (* (floor f) empan))) )
        (fonction r)) ) ) )

(define (symetriser fonction)
  (lambda (x) 
    (- (fonction x)) ) )

(define (decaler fonction delta)
  (lambda (x)
    (fonction (+ x delta)) ) )

(define (dessiner fonction debut fin pas min max ligne)
  (define (display-star y)
    (let ((n (inexact->exact (* ligne (/ (- y min) (- max min))))))
      (do ((i 0 (+ 1 i)))
          ((> i ligne)(display "  "))
        (if (= i n)  (display "*") (display " ")) ) ) )
  (do ((x debut (+ x pas)))
      ((> x fin) fonction)
    (let ((y (fonction x)))
      (display-star y)
      ;; pour voir les vraies valeurs
      (display x)
      (display "=>")
      (display y)
      (newline) ) ) )

;;; Memo fonctions et caches.

(define (memo f)
  (let ((au-moins-un-resultat #f)
        (dernier-argument #f)
        (dernier-resultat #f) )
    (lambda (x)
      (if (and au-moins-un-resultat (equal? x dernier-argument) )
          dernier-resultat
          (let ((resultat (f x)))
            (set! dernier-argument x)
            (set! dernier-resultat resultat)
            (set! au-moins-un-resultat #t)
            resultat ) ) ) ) )

(define (faire-longue-liste element fin longueur)
  (if (> longueur 0)
      (faire-longue-liste element (cons element fin) (- longueur 1))
      fin ) )

(define (fib n)
  (cond ((= n 1) 1)
        ((= n 2) 1)
        (else (+ (fib (- n 1)) (fib (- n 2)))) ) )

(define (cache f taille)
  (let ((arguments (make-vector taille #f))
        (resultats (make-vector taille #f))
        (libre 0) )
    (define (echanger i j)
      (let ((a (vector-ref arguments i))
            (r (vector-ref resultats i)) )
        (vector-set! arguments i (vector-ref arguments j))
        (vector-set! resultats i (vector-ref resultats j))
        (vector-set! arguments j a)
        (vector-set! resultats j r) 
        r ) )
    (define (memoriser x i)
      (let ((r (f x)) ) 
        (vector-set! arguments i x)
        (vector-set! resultats i r)
        r ) )
    (lambda (x)
      (let scruter ((i 0))
        (if (>= i libre)
            ;; le cache n'est pas plein, il faut vraiment calculer
            (if (< libre taille)
                (let ((i libre))
                  (set! libre (+ 1 libre))
                  (memoriser x i) )
                (memoriser x (- taille 1)) )
            (if (equal? (vector-ref arguments i) x)
                ;; on remonte la ligne du cache
                (echanger i 0)
                (scruter (+ i 1)) ) ) ) ) ) )

;;; Autre solution de Bruno Salvy
(define (cache2 f taille)
  (let* ((init (cons #t #f))
         (lastargval (vector->list (make-vector taille (cons init init)))) )
    (lambda (x)
      (let ((found (assoc x lastargval)))
        (if found (cdr found)
            (begin (set! found (f x))
                   (set! lastargval (append! (cdr lastargval)
                                             (list (cons x found))))
                   found ) ) ) ) ) )

;;;;;;;;;;;;;;;; compilation du filtrage

;;; filtre ::= { atome | ?- | ... } | ( filtre . filtre )
(define (compiler-filtrer3 filtre)
  (define (filtrer3-liste expressions filtres)
    (if (pair? filtres)
        (if (equal? (car filtres) '...)
            (let ((loop (gensym))
                  (e (gensym)) )
              `(let ,loop ((,e ,expressions))
                    (or ,(filtrer3-liste e (cdr filtres))
                        (and (pair? ,e)
                             (,loop (cdr ,e)) ) ) ) )
            `(and (pair? ,expressions)
                  ,(filtrer3 `(car ,expressions) (car filtres))
                  ,(filtrer3-liste `(cdr ,expressions) (cdr filtres)) ) )
        `(equal? ,expressions ',filtres) ) )
  (define (filtrer3 expression filtre)
    (if (equal? filtre '?-)
        '#t
        (if (equal? filtre '...)
            `(error 'filtrer3 "... ne peut survenir ici")
            (if (pair? filtre) 
                (filtrer3-liste expression filtre)
                `(equal? ,expression ',filtre) ) ) ) )
  `(lambda (expression) ,(filtrer3 'expression filtre)) )
;;; (compiler-filtrer3 '?-)
;;; (compiler-filtrer3 'foo)
;;; (pp (compiler-filtrer3 '(foo ?- bar)))
;;; (pp (compiler-filtrer3 '(foo ?- ...)))
;;; (pp (compiler-filtrer3 '(foo ?- ... bar)))
;;; (pp (compiler-filtrer3 '((foo ...) (... bar))))


;;;;;;;;;;;;;;;; Boyer-Moore

(define (decalage lettre fitom)
  (define (calcul lettre fitom resultat)
    (if (and (pair? fitom)
             (not (equal? lettre (car fitom))) )
        (calcul lettre (cdr fitom) (+ 1 resultat))
        resultat ) )
  (calcul lettre fitom 0) )

(define (boyer-moore motif texte)
  (let ((fitom (reverse motif)))
    (define (bm lettres longueur texte)
      (if (pair? lettres)
          (if (>= (length texte) longueur)
              (let ((lettre-en-regard (list-ref texte longueur)))
                (if (equal? (car lettres) lettre-en-regard)
                    (bm (cdr lettres) (- longueur 1) texte)
                    (let ((n (decalage lettre-en-regard lettres)))
                      (bm fitom (- (length motif) 1) (list-tail texte n)) ) ) )
              #f )
          texte ) )
    (bm fitom (- (length motif) 1) texte) ) )

(define (compiler-boyer-moore motif)
  (define (cbm motif texte)
    (let ((fitom  (reverse motif)))
      (define (ibm lettres texte)
        (if (pair? lettres)
            `(case (list-ref ,texte ,(- (length lettres) 1))
               ((,(car lettres))
                ,(ibm (cdr lettres) texte) )
               ,@(let enum ((lettres  (cdr lettres))
                            (dejavues (list (car lettres))) )
                   (if (pair? lettres)
                       (if (member (car lettres) dejavues)
                           (enum (cdr lettres) dejavues)
                           `(((,(car lettres))
                              (cbmf (list-tail 
                                     ,texte
                                     ,(decalage (car lettres) fitom))) )
                             ,@(enum (cdr lettres)
                                     (cons (car lettres) dejavues) ) ) )
                       `((else (cbmf (list-tail ,texte ,(length motif))))) ) ) )
            texte ) )
      `(let cbmf ((,texte ,texte))
         (if (>= (length texte) ,(length motif))
             ,(ibm fitom texte)
             #f ) ) ) )
  `(lambda (texte)
     ,(cbm motif 'texte) ) )

;;;; encore des filtres 

;;; filtre ::= { atome | ?- | ... } | ( filtre . filtre )
(define (filtrer4 expression filtre)
  (define (filtrer4-liste expressions filtres)
    (if (pair? filtres)
        (if (equal? (car filtres) '...)
            (or (filtrer4-liste expressions (cdr filtres))
                (and (pair? expressions)
                     (filtrer4-liste (cdr expressions) filtres) ) )
            (and (pair? expressions)
                 (filtrer4 (car expressions) (car filtres))
                 (filtrer4-liste (cdr expressions) (cdr filtres)) ) )
        (equal? expressions filtres) ) )
  (define (filtrer4-or expression filtres)
    (if (pair? filtres)
        (or (filtrer4 expression (car filtres))
            (filtrer4-or expression (cdr filtres)) )
        #f ) )
  (or (equal? filtre '?-) 
      (if (equal? filtre '...)
          (error 'filtrer4 "... ne peut survenir ici") )
          (if (pair? filtre) 
              (if (equal? (car filtre) '*or)
                  (filtrer4-or expression (cdr filtre))
                  (filtrer4-liste expression filtre) )
              (equal? expression filtre) ) ) )

;;; filtre ::= { atome | ?- | ... } | ( filtre . filtre )
(define (compiler-filtrer4 filtre)
  (define (filtrer4-liste expressions filtres)
    (if (pair? filtres)
        (if (equal? (car filtres) '...)
            (let ((loop (gensym))
                  (e (gensym)) )
              `(let ,loop ((,e ,expressions))
                    (or ,(filtrer4-liste e (cdr filtres))
                        (and (pair? ,e)
                             (,loop (cdr ,e)) ) ) ) )
            `(and (pair? ,expressions)
                  ,(filtrer4 `(car ,expressions) (car filtres))
                  ,(filtrer4-liste `(cdr ,expressions) (cdr filtres)) ) )
        `(equal? ,expressions ',filtres) ) )
  (define (filtrer4-or expression filtres)
    (if (pair? filtres)
        `(or ,(filtrer4 expression (car filtres))
             ,(filtrer4-or expression (cdr filtres)) )
        '#f ) )
  (define (filtrer4 expression filtre)
    (if (equal? filtre '?-)
        '#t
        (if (equal? filtre '...)
            `(error 'filtrer4 "... ne peut survenir ici")
            (if (pair? filtre) 
                (if (equal? (car filtre) '*or)
                    (filtrer4-or expression (cdr filtre))
                    (filtrer4-liste expression filtre) )
                `(equal? ,expression ',filtre) ) ) ) )
  `(lambda (expression) ,(filtrer4 'expression filtre)) )
;;; (compiler-filtrer4 '?-)
;;; (compiler-filtrer4 'foo)
;;; (pp (compiler-filtrer4 '(foo ?- bar)))
;;; (pp (compiler-filtrer4 '(foo ?- ...)))
;;; (pp (compiler-filtrer4 '(foo ?- ... bar)))
;;; (pp (compiler-filtrer4 '((foo ...) (... bar))))
;;; (pp (compiler-filtrer4 '((*or j je) ... (fatigue deprime) ...)))

;;; Inspire' par un programme de Je'ro^me Chailloux
(define (Freud)
  (define (repondre phrase base)
    (if (pair? base)
        (let ((filtre (caar base))
              (reponse (cdar base)) )
          (if (filtre phrase) 
              (reponse phrase)
              (repondre phrase (cdr base)) ) )
        (begin (display "Je ne vous comprend pas tres bien.")
               (newline)
               #t ) ) )
  (define (au-revoir n)
    (display "L'important, c'est de vouloir guerir ...")(newline)
    (display "Cela vous fera ")
    (display (* n 47))
    (display " francs.") )
  (display "Allongez-vous et causons.")(newline)
  (let analyse ((e (read))(n 1))
    (if (eof-object? e)
        (au-revoir n)
        (if (repondre e comportement-de-Freud)
            (analyse (read) (+ 1 n))
            (au-revoir n) ) ) ))

(define comportement-de-Freud '())

(define-macro (definir-comportement filtre . comportement)
  `(begin 
     (set! comportement-de-Freud
           (cons (cons ,(compiler-filtrer4 filtre)
                       (lambda (phrase) . ,comportement) )
                 comportement-de-Freud ) )
     'OK ) )

(definir-comportement
  (*or (au revoir) (adieu))
  #f )     ; \#f clot la conversation

(definir-comportement
  ((*or j je) ... (*or deprime fatigue) ...)
  (display "Racontez-moi cela en detail.")
  (newline)
  #t )     ; \#t poursuit l'analyse

(definir-comportement
  ((*or vous tu) ...)
  (display "Parlez-moi plutot de vous.")
  (newline)
  #t )

(definir-comportement
  (?-)
  (display "Soyez plus explicite.")
  (newline)
  #t )

(definir-comportement
  (... (*or pere mere) ...)
  (display "Comment s'est deroule votre enfance ?")
  (newline)
  #t )

(define (creer-psychologue comportement)
  (define (repondre phrase base)
    (if (pair? base)
        (let ((filtre (caar base))
              (reponse (cdar base)) )
          (if (filtre phrase) 
              (reponse phrase)
              (repondre phrase (cdr base)) ) )
        ;; Le psy n'a pas de r\'eponse toute pr\^ete
        #f ) )
  (define (au-revoir n)
    (display "Cela vous fera ")
    (display (* n 47)) ; tarif syndical constant
    (display " francs.") )
  (lambda ()
    (display "Allongez-vous et causons.")(newline)
    (let analyse ((e (read))(n 1))
      (if (eof-object? e)
          (au-revoir n)
          (if (repondre e comportement)
              (analyse (read) (+ 1 n))
              (au-revoir n) ) ) ) ) )

(define-macro (definir-psychologue nom . comportements)
  `(define ,nom
     (creer-psychologue
      (list ,@comportements) ) ) )

(define-macro (definir-comportement motif . reaction)
  `(cons ,(compiler-filtrer4 motif)
         (lambda (phrase) . ,reaction) ) )

(definir-psychologue Dumbkopf
  (definir-comportement (... Freud ...)
    (display "Sortez immediatement de mon cabinet!")
    (newline)
    #f )
  (definir-comportement (...)
    (display "Pouvez-vous repeter?")
    (newline)
    #t ) )

;;;;;;;;;;;;;;;; flots
;;; Don't forget to load stream.scm:     (loadq "stream.scm")

(define (map-stream1 fonction stream)
  (if (empty-stream? stream)
      the-empty-stream
      (cons-stream (fonction (head stream))
                   (map-stream1 fonction (tail stream)) ) ) )

;;; Returns true only if P is true on at least one term of the lists in args.
;;; Only used once in the if-meroon-feature macro.

(define (any? p . args)
  (let ormap ((args args) (value #f))
    (if (let any-at-end? ((ls args))
          (and (pair? ls)
               (or (not (pair? (car ls)))
                   (any-at-end? (cdr ls)))))
        value
        (let ((value (apply p (map car args))))
          (or value (ormap (map cdr args) value))))))

(define (map-stream fonction . streams)
  (case (length streams)
    ((0) the-empty-stream)
    ((1) (map-stream1 fonction (car streams)))
    (else
     (if (any? empty-stream? streams)
         the-empty-stream
         (cons-stream (apply fonction (map head streams))
                      (apply map-stream fonction (map tail streams)) ) ) ) ) )

(define integers 
  (cons-stream 0 (map-stream (lambda (n) (+ 1 n)) integers)) )

(define (extraire stream n)
  (if (empty-stream? stream)
      the-empty-stream?
      (if (> n 0)
          (cons (head stream)
                (extraire (tail stream) (- n 1)) )
          '() ) ) )

(define (fusionner stream1 stream2)
  (if (empty-stream? stream1)
      stream2
      (if (empty-stream? stream2)
          stream1
          (cons-stream (head stream1)
                       (cons-stream (head stream2)
                                    (fusionner (tail stream1)
                                               (tail stream2) ) ) ) ) ) )

(define self-integers
  (cons-stream (head integers)
               (fusionner self-integers (tail integers)) ) )

(define (ordonner predicat stream1 stream2)
  ;; On assume que {\tt stream1} et {\tt stream2} sont ordonn\'es
  (if (empty-stream? stream1)
      stream2
      (if (empty-stream? stream2)
          stream1
          (cond ((predicat (head stream1) (head stream2))
                 (cons-stream (head stream1) 
                              (ordonner predicat (tail stream1) stream2) ) )
                ((predicat (head stream2) (head stream1))
                 (cons-stream (head stream2)
                              (ordonner predicat stream1 (tail stream2)) ) )
                (else (ordonner predicat stream1 (tail stream2))) ) ) ) )
      
(define hamming
  (let ((integers+ (tail integers)))
    (ordonner < 
              (map-stream (lambda (n) (* 2 n)) integers+)
              (ordonner < 
                        (map-stream (lambda (n) (* 3 n)) integers+)
                        (map-stream (lambda (n) (* 5 n)) integers+) ) ) ) )

;;; Exercises on macros (previously in tpmacros.scm)

(define-macro (ifn condition alors sinon)
  `(if ,condition ,sinon ,alors) )

(define-macro (ifn2 condition alors . sinon)
  (if (pair? sinon)
      `(if ,condition (begin . ,sinon) ,alors)
      `(if (not ,condition) ,alors) ) )

(define-macro (yf condition alors sinon)
  `(let ((condition ,condition)
         (alors (lambda () ,alors))
         (sinon (lambda () ,sinon)) )
     (if condition
         (condition (alors))
         (sinon) ) ) )

;;; Continuations: echappement

(define (multiplier-arbre n*)
  (call/cc 
   (lambda (exit)
     (define (iterer n*)
       (if (pair? n*)
           (* (iterer (car n*))
              (iterer (cdr n*)) )
           (if (null? n*) 1
               (if (= 0 n*)
                   (exit 0)
                   n* ) ) ) )
     (iterer n*) ) ) )

(define (oter-symbole s s*)
  (define (oter s* k)
    (if (pair? s*)
        (if (eq? (car s*) s)
            (cdr s*)
            (cons (car s*) (oter (cdr s*) k)) )
        (k) ) )
  (call/cc
   (lambda (k)
     (oter s* (lambda () (k s*))) ) ) )

(define (oter-completement-symbole s s*)
  (define (oter s* k)
    (if (pair? s*)
        (if (eq? (car s*) s)
            (oter-tout (cdr s*))
            (cons (car s*) (oter (cdr s*) k)) )
        (k) ) )
  (define (oter-tout s*)
    (call/cc
     (lambda (k)
       (oter s* (lambda () (k s*))) ) ) )
  (oter-tout s*) )

(define (kfact n k)
  (if (> n 1)
      (kfact (- n 1) 
             (lambda (r)
               (k (* n r)) ) )
      (k 1) ) )

(define (flatten e)
  (if (pair? e)
      (append (flatten (car e))
              (flatten (cdr e)) )
      (if (null? e) e (list e)) ) )

(define (kflatten e k)
  (if (pair? e)
      (kflatten (car e) 
                (lambda (ra)
                  (kflatten (cdr e)
                            (lambda (rb)
                              (k (append ra rb)) ) ) ) )
      (if (null? e) (k e) (k (list e))) ) )

(define (flatten2 e)
  (define (flat l r)
    (if (pair? l)
        (flat (car l) (flat (cdr l) r))
        (if (null? l) r (cons l r)) ) )
  (flat e '()) )

(define (kflatten2 e k)
  (define (kflat l r k)
    (if (pair? l)
        ;; Le {\tt cdr} est trait\'e en premier.
        (kflat (cdr l) r (lambda (result)
                           (kflat (car l) result k) ) )
        (if (null? l) (k r) (k (cons l r))) ) )
  (kflat e '() k) )

(define (lineariser e)
  (cond ((pair? e)
         (case (car e)
           ((+ *)
            (cons (car e) (apply append (map lineariser (cdr e)))) )
           ((-)
            ;; Distinguer les - unaires ou binaires.
            (case (length (cdr e))
              ((1) (cons '-- (lineariser (cadr e))))
              ((2) (cons '- (apply append (map lineariser (cdr e))))) ) ) ) )
        (else (list e)) ) )

(define (elever l)
  (define (analyser l k)
    (if (pair? l)
        (case (car l)
          ((+ * -)
           (analyser (cdr l)
                     (lambda (e1 l1)
                       (analyser l1
                                 (lambda (e2 l2)
                                   (k `(,(car l) ,e1 ,e2) l2) ) ) ) ) )
          ((--)
           (analyser (cdr l)
                     (lambda (e1 l1)
                       (k `(- ,e1) l1) ) ) )
          (else (k (car l) (cdr l))) )
        (error 'elever 'termes-manquant l) ) )
  (analyser l (lambda (e ll)
                (if (null? ll) 
                    e
                    (error 'elever 'termes-en-trop ll) ) )) )

(define (divide p q f)
  (f (quotient p q) (remainder p q)) )

(define (bezout n p k)    ; assume $n>p$
  (divide
   n p (lambda (q r)
         (if (= r 0)
             (if (= p 1)
                 (k 0 1)  ; since $ 0 \times 1 - 1 \times 0 = 1 $
                 (error "not relatively prime" n p) )
             (bezout
              p r (lambda (u v)
                    (k v (- u (* v q))) ) ) ) ) ) )

(define (verifier-bezout n p)
  (bezout n p (lambda (u v)
                (+ (* u n) (* v p)) )) )

(define (filtrer6 expression filtre)
  (define (filtrer6-liste expressions filtres env succes echec)
    (if (pair? filtres)
        (if (equal? (car filtres) '...)
            (filtrer6-liste expressions (cdr filtres) env succes 
                            (lambda ()
                              (if (pair? expressions)
                                  (filtrer6-liste (cdr expressions) filtres
                                                  env succes echec )
                                  (echec) ) ) )
            (if (pair? expressions)
                (filtrer6-expression
                 (car expressions) (car filtres) env
                 (lambda (env echec)
                   (filtrer6-liste (cdr expressions) (cdr filtres) env
                                   succes echec ) )
                 echec )
                (echec) ) )
        (if (equal? expressions filtres) (succes env echec) (echec)) ) )
  (define (filtrer6-expression expression filtre env succes echec)
    (if (equal? filtre '?-)
        (succes env echec)
        (if (equal? filtre '...)
            (error 'filtrer6 "... ne peut survenir ici")
            (if (pair? filtre)
                (filtrer6-liste expression filtre env succes echec)
                (if (equal? filtre expression)
                    (succes env echec)
                    (echec) ) ) ) ) )
  (filtrer6-liste expression filtre '() (lambda (env echec) env) (lambda () #f)) )

(define (filtrer-variable? s)
  (and (symbol? s)
       (let ((str (symbol->string s)))
         (and (> (string-length str) 0)
              (char=? (string-ref str 0) #\?) ) ) ) )

(define (filtrer7 expression filtre)
  (define (filtrer7-liste expressions filtres env succes echec)
    (if (pair? filtres)
        (if (equal? (car filtres) '...)
            (filtrer7-liste expressions (cdr filtres) env succes 
                            (lambda ()
                              (if (pair? expressions)
                                  (filtrer7-liste (cdr expressions) filtres
                                                  env succes echec )
                                  (echec) ) ) )
            (if (pair? expressions)
                (filtrer7-expression (car expressions) 
                                     (car filtres) 
                                     env
                                     (lambda (env echec)
                                       (filtrer7-liste (cdr expressions) 
                                                       (cdr filtres) 
                                                       env
                                                       succes
                                                       echec ))
                                     echec )
                (echec) ) )
        (if (equal? expressions filtres) (succes env echec) (echec)) ) )
  (define (filtrer7-expression expression filtre env succes echec)
    (cond 
     ((equal? filtre '?-) (succes env echec))
     ((equal? filtre '...) (error 'filtrer7 "... ne peut survenir ici"))
     ((filtrer-variable? filtre)
      (let ((p (assq filtre env)))
        (if (pair? p)
            (if (equal? expression (cdr p))
                (succes env echec)
                (echec) )
            (succes (cons (cons filtre expression) env) echec) ) ) )
     ((pair? filtre) (filtrer7-liste expression filtre env succes echec))
     (else (if (equal? filtre expression)
               (succes env echec)
               (echec) ) ) ) )
  (filtrer7-expression expression filtre '() 
                       (lambda (env echec) env)
                       (lambda () #f) ) )


;;; Calculette

(define (calculette1 e)
  (define (execute e s k)
    (cond
     ((number? e) (k e s))
     ((pair? e)
      (case (car e)
        ((+) (execute (cadr e) s
                      (lambda (r1 s1)
                        (execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (k (+ r1 r2) s2) ) ) ) ))
        ((-) (execute (cadr e) s
                      (lambda (r1 s1)
                        (execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (k (- r1 r2) s2) ) ) ) ))
        ((*) (execute (cadr e) s
                      (lambda (r1 s1)
                        (execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (k (* r1 r2) s2) ) ) ) ))
        ((STO) (execute (cadr e) s
                        (lambda (r ss)
                          (k r r) ) ))
        ((RCL) (if s (k s s) (error 'calculette "Memoire non initialisee")))
        ((PRINT) (execute (cadr e) s
                          (lambda (r ss)
                            (display "===> ")(display r)(newline)
                            (k r ss) ) )) ) ) ) )
  (execute e #f (lambda (r s) r)) )

(define (calculette2 e)
  (define (execute e s k)
    (cond
     ((number? e) (k e s))
     ((pair? e)
      (case (car e)
        ((+) (execute (cadr e) s
                      (lambda (r1 s1)
                        (execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (k (+ r1 r2) s2) ) ) ) ))
        ((-) (execute (cadr e) s
                      (lambda (r1 s1)
                        (execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (k (- r1 r2) s2) ) ) ) ))
        ((*) (execute (cadr e) s
                      (lambda (r1 s1)
                        (execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (k (* r1 r2) s2) ) ) ) ))
        ((STO) (execute (cadr e) s
                        (lambda (r ss)
                          (k r r) ) ))
        ((RCL) (if s (k s s) (error 'calculette "Memoire non initialisee")))
        ((EITHER) (execute (cadr e) s k)
                  (execute (caddr e) s k) )
        ((PRINT) (execute (cadr e) s
                          (lambda (r ss)
                            (display "===> ")(display r)(newline)
                            (k r ss) ) )) ) ) ) )
  (execute e #f (lambda (r s) r)) )

(define (calculette3 e)
  ;; Montrer l'\'etat de la calculette.
  (define (display-state fn args)
    (cond ((eq? fn execute)
           (display "<<< ")
           (display (car args))
           (newline) )
          (else (display ">>> ")
                (display (car args))
                (display "[memory= ")
                (display (cadr args))
                (display "]")
                (newline) ) ) )
  ;; Un petit ordonnanceur
  (define threads '())
  (define (schedule! fn . args)
    (set! threads (append threads (list (cons fn args))))
    (if (pair? threads)
        (let* ((thread (car threads))
               (fn     (car thread))
               (args   (cdr thread)) )
          (set! threads (cdr threads))
          (display-state fn args)
          (apply fn args) )
        ;; plus aucune t\^ache \`a accomplir.
        'done ) )
  (define (add-to-scheduler! fn . args)
    (set! threads (append threads (list (cons fn args)))) )
  ;; L'\'evaluateur d'expression instrument\'e.
  (define (execute e s k)
    (cond
     ((number? e) (schedule! k e s))
     ((pair? e)
      (case (car e)
        ((+) (schedule! execute (cadr e) s
                      (lambda (r1 s1)
                        (schedule! execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (schedule! k (+ r1 r2) s2) ) ) ) ))
        ((-) (schedule! execute (cadr e) s
                      (lambda (r1 s1)
                        (schedule! execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (schedule! k (- r1 r2) s2) ) ) ) ))
        ((*) (schedule! execute (cadr e) s
                      (lambda (r1 s1)
                        (schedule! execute (caddr e) s1
                                 (lambda (r2 s2)
                                   (schedule! k (* r1 r2) s2) ) ) ) ))
        ((STO) (schedule! execute (cadr e) s
                        (lambda (r ss)
                          (schedule! k r r) ) ))
        ((RCL) (if s (schedule! k s s) 
                   (error 'calculette "Memoire non initialisee") ))
        ((EITHER) (add-to-scheduler! execute (cadr e) s k)
                  (schedule! execute (caddr e) s k) )
        ((PRINT) (schedule! execute (cadr e) s
                          (lambda (r ss)
                            (display "===> ")(display r)(newline)
                            (schedule! k r ss) ) )) ) ) ) )
  (schedule! execute e #f (lambda (r s) r)) )

(define-macro (with-parallelism . body)
  (let ((add-to-scheduler! (gensym))
        (call-scheduler    (gensym))
        (threads           (gensym))
        (results           (gensym))
        (result            (gensym))
        (return            (gensym)) )
    `(call/cc
      (lambda (,return)
        (letrec ((either (lambda args
                           (call/cc (lambda (k)
                                      (for-each (lambda (arg)
                                                  (,add-to-scheduler! k arg) )
                                                args )
                                      (,call-scheduler) )) ))
                 ;; On ne peut \'ecrire {\tt(suicide ,call-scheduler)}!
                 (suicide (lambda ()
                            (,call-scheduler) ))
                 (,results '())
                 (,threads '())
                 (,call-scheduler (lambda ()
                                    (if (pair? ,threads)
                                        (let ((thread (car ,threads)))
                                          (set! ,threads (cdr ,threads))
                                          (apply (car thread) (cdr thread)) )
                                        (,return ,results) ) ))
                 (,add-to-scheduler! 
                  (lambda (f . args)
                    (set! ,threads (append ,threads
                                           (list (cons f args)) )) )) )
          ;; Cr\'eer la premi\`ere t\^ache.
          (,add-to-scheduler!
           (lambda ()
             (let ((,result (begin . ,body)))
               (set! ,results (cons ,result ,results))
               (,call-scheduler) )
             (suicide) ) )
          (,call-scheduler) ) ) ) ) )

(define-macro (parallel . expressions)
  (let ((k (gensym)))
    `(do-parallel . ,(map (lambda (e) 
                            `(lambda (,k) (,k ,e)) )
                          expressions )) ) )

(define-macro (with-parallelism2 . body)
  (let ((add-to-scheduler! (gensym))
        (call-scheduler    (gensym))
        (threads           (gensym))
        (results           (gensym))
        (result            (gensym))
        (return            (gensym)) )
    `(call/cc
      (lambda (,return)
        (letrec ((do-parallel
                  (lambda tasks
                    (call/cc
                     (lambda (k)
                       (map (lambda (task)
                              (,add-to-scheduler! task k) )
                            tasks )
                       (,call-scheduler) ) ) ) )
                 (suicide (lambda ()
                            (,call-scheduler) ))
                 (yield   (lambda ()
                            (call/cc (lambda (k)
                                       (,add-to-scheduler! k 'continue)
                                       (,call-scheduler) )) ))
                 (,results '())
                 (,threads '())
                 (,call-scheduler (lambda ()
                                    (if (pair? ,threads)
                                        (let ((thread (car ,threads)))
                                          (set! ,threads (cdr ,threads))
                                          (apply (car thread) (cdr thread)) )
                                        (,return ,results) ) ))
                 (,add-to-scheduler! 
                  (lambda (f . args)
                    (set! ,threads (append ,threads
                                           (list (cons f args)) )) )) )
          (,add-to-scheduler! 
           (lambda ()
             (let ((,result (begin . ,body)))
               (set! ,results (cons ,result ,results))
               (,call-scheduler) ) ) )
          (,call-scheduler) ) ) ) ) )

(define-macro (coroutine variable . body)
  (let ((value    (gensym))
        (return   (gensym))
        (behavior (gensym))
        (self     (gensym)) )
    `(letrec ((,variable 'wait)
              (,self (lambda (,value) 
                       (set! ,variable ,value)
                       (coroutine-return (begin . ,body)) ))
              (coroutine-resume
               (lambda (c v)
                 (call/cc (lambda (k)
                            (set! ,self k)
                            (set! ,variable (c v))
                            (,self ,variable) ) )) )
              (coroutine-return
               (lambda (v)
                 (set! ,self (lambda (x) x))
                 v ) ) )
       (lambda (x) (,self x)) ) ) )

(define (coroutine-start c v)
  (c v) )

(define (same-fringe tree1 tree2)
  (define (visit tree fn)
    (define (walk tree)
      (if (pair? tree)
          (begin (walk (car tree))
                 (walk (cdr tree)) )
          (if tree (fn tree)) ) )
    (walk tree) )
  (call/cc 
   (lambda (exit)
     (letrec ((sentinel (list 'sentinel))
              (c1 (coroutine void
                             (visit tree1 (lambda (leaf) 
                                            (coroutine-resume cmp leaf) ))
                             (coroutine-resume cmp sentinel) ))
              (c2 (coroutine void
                             (visit tree2 (lambda (leaf) 
                                            (coroutine-resume cmp leaf) ))
                             (coroutine-resume cmp sentinel) ))
              (cmp (coroutine leaf
                              (let find ((leaf1 (coroutine-resume c1 sentinel))
                                         (leaf2 (coroutine-resume c2 sentinel)) )
                                (display (list 'compare leaf1 leaf2))
                                (if (eq? leaf1 leaf2)
                                    (if (eq? leaf1 sentinel)
                                        (exit #t)
                                        (find (coroutine-resume c1 sentinel)
                                              (coroutine-resume c2 sentinel) ) )
                                    (exit #f) ) ) )) )
       (coroutine-start cmp 'go) ) ) ) )

;;; end of tps.scm
