;;; $Id: tps.tst,v 1.8 1996/09/20 11:41:48 queinnec Exp $

;;; Les tests de tps.scm (beaucoup restent a faire)

(reconstruire '(a b))
   (cons 'a (cons 'b '()))

(set-equal? (stricts-doublons poeme-pi) (stricts-doublons2 poeme-pi))
   #t

(let ((l '((q u e (j a i m e)((a) f a i r
             e) a p p r e n d r e) ((u n) ((n o m b r e)
            (u t i l e (a u x))) s a g e s))))
  (set-equal? (extraire-stricts-doublons l)
              (extraire-stricts-doublons2 l) ) )
   #t

(iota 0 4)
   (0 1 2 3)
(map-car (lambda (n) (+ n 1))
         (iota 2 5) )
   (3 4 5)
(fact-orielle 6)
   720

((compose cdr car) '(1 2 3))
   2
((ncompose list length) 'a 'b 'c)
   3
((compose-n cdr cdr cdr car) '(a b c d e))
   d

;;; Boyer-Moore

(boyer-moore '(b a b a r) 
             '(e n c o r e - g a b a r i t - b a b a r - f u t - g r a n d) )
   (b a b a r - f u t - g r a n d)
(boyer-moore '(b a b a r) 
             '(e n c o r e - g a b a r i t - b a b u r - f u t - g r a n d) )
   #f
(pp (compiler-boyer-moore '(b a b a r)))
   ---
(define babar (eval (compiler-boyer-moore '(b a b a r))))
   ---
(babar '(e n c o r e - g a b a r i t - b a b a r - f u t - g r a n d))
   (b a b a r - f u t - g r a n d)
(babar '(e n c o r e - g a b a r i t - b a b u r - f u t - g r a n d))
   #f

;;; streams
(empty-stream? (map-stream +))
   #t
(extraire (map-stream + integers)
          10 )
   (0 1 2 3 4 5 6 7 8 9)
(extraire (map-stream + integers integers)
          3 )
   (0 2 4) 

;;; continuations: echappement

(multiplier-arbre '())
   1
(multiplier-arbre '(1 2 3 (4 5 6)))
   720
(multiplier-arbre '(1 2 (3 4 0 5 6) (7 8 9 1 2 (3 4 5 6 7 8 a 9 0))))
   0

(oter-symbole 'a '(b c d))
   (b c d)
(oter-symbole 'a '(a b c))
   (b c)
(oter-symbole 'a '(b c a d a e))
   (b c d a e)
(let ((l '(a b c)))
  (eq? (cdr l) (oter-symbole 'a l)) )
   #t

(oter-completement-symbole 'a '(b c d))
   (b c d)
(oter-completement-symbole 'a '(a b c))
   (b c)
(oter-completement-symbole 'a '(b c a d a e))
   (b c d e)
(let ((l '(a b c)))
  (eq? (cdr l) (oter-completement-symbole 'a l)) )
   #t
(let ((l '(a b a c)))
  (eq? (cdddr l) 
       (cdr (oter-completement-symbole 'a l)) ) )
   #t

(kfact 5 (lambda (x) (- x)))
   -120

(flatten 'a)
   (a)
(flatten '(a (b . c) . d))
   (a b c d)
(kflatten 'a (lambda (x) x))
   (a)
(kflatten '(a (b . c) . d) (lambda (x) x))
   (a b c d)
(flatten2 'a)
   (a)
(flatten2 '(a (b . c) . d))
   (a b c d)
(kflatten2 'a (lambda (x) x))
   (a)
(kflatten2 '(a (b . c) . d) (lambda (x) x))
   (a b c d)

(lineariser '(+ (- 3) (* (- 2 3) 5)))
   (+ -- 3 * - 2 3 5)
(elever '(+ -- 3 * - 2 3 5))
   (+ (- 3) (* (- 2 3) 5)))

(bezout 45 5 list)
    ***
(bezout 45 53 list)
   (-20 17)
(bezout 1991 1960 list)
   (-569 578)
(verifier-bezout 45 53)
   1
(verifier-bezout 1991 1960)
   1

(filtrer6 '(a b) '(a b))
   ()
(filtrer6 '(a a) '(?- ?-))
   ()
(filtrer6 '(a b c) '(?- ?-))
   #f
(filtrer6 '(a b c) '(?- ?- ?- ?-))
   #f
(filtrer6 '(a b c d e) '(... d ...))
   ()
(filtrer6 '((a b c) (d e)) '((...) (?- ?-)))
   ()

(filtrer7 '(a a) '(?x ?x))
   ((?x . a))
(filtrer7 '(a b) '(?x ?x))
   #f
(filtrer7 '((a b c) (r g b)) '((... ?x ...) (... ?x ...)))
   ((?x . b))
(filtrer7 '((a b c) (r g d)) '((... ?x ...) (... ?x ...)))
   #f

;;; calculette

(calculette1 '123)
   123
(calculette1 '(+ 1 (+ 2 3)))
   6
(calculette1 '(- 5 2))
   3
(calculette1 '(* 5 6))
   30
(calculette1 '(+ 1 (PRINT 2)))
   3
(calculette1 '(+ (STO (* 4 5)) (+ (RCL) 1)))
   41
(calculette1 '(+ 2 (RCL)))
   ***

(calculette2 '(either 1 2))
   (or 1 2)
(calculette2 '(PRINT (+ (STO 3) (either 5 7))))
   (or 8 10)
(calculette2 '(PRINT (* (EITHER 3 5) (EITHER 7 11))))
   (or 21 33 35 55)
(calculette2 '(PRINT (* (STO (EITHER 3 5)) (EITHER (RCL) 11))))
   (or 9 33 25 55)

(calculette3 '(either 1 2))
  (or 1 2)
(calculette3 '(PRINT (+ (STO 3) (either 5 7))))
   (or 8 11)
(calculette3 '(PRINT (* (EITHER 3 5) (EITHER 7 11))))
   (or 21 33 35 55)
(calculette3 '(PRINT (* (STO (EITHER 3 5)) (EITHER (RCL) 11))))
   (or 9 33 25 55)

(with-parallelism (either 1 2))
  (multiple 1 2)
(with-parallelism (+ 1 (either (* 2 3)
                               (* 3 4)
                               (+ 2 3) )))
  (multiple 7 13 6)
(with-parallelism
 (+ 1 (suicide)) )
   ()
(with-parallelism
 (either (suicide) (+ 1 (suicide))) )
   ()
(with-parallelism 
 (let ((n (either 1 2 3)))
   (if (= n 2) (suicide) n) ) )
  (multiple 1 3)
(with-parallelism
 (let ()
   (define (iota start stop)
     (if (< start stop)
         (cons start (iota (+ start 1) stop))
         '() ) )
   (define (//iota start stop)
     (apply either (iota start stop)) )
   (list (//iota 0 9))) )
   (multiple (0) (1) (2) (3) (4) (5) (6) (7) (8))

(with-parallelism2
 (parallel 1 2 3) )
   (multiple 1 2 3)
(with-parallelism2
 (let ()
   (define (//iota start stop)
     (if (< start stop)
         (parallel start (//iota (+ start 1) stop))
         (suicide) ) )
   (list (//iota 0 9)) ) )
   (multiple (0) (1) (2) (3) (4) (5) (6) (7) (8))
(with-parallelism2
 (let ()
   (define (walk tree)
     (if (pair? tree)
         (parallel (walk (car tree))
                   (walk (cdr tree)) )
         (begin (yield) (list tree)) ) )
   (parallel (walk '(a (b . c) ((d e) . f) . g))
             (walk '(((1 . 2) 3 (4 5) . 6) 7 8)) ) ) )
   ---

;;; coroutines
(let ((c (coroutine x x)))
  (coroutine-start c 33) )
   33
(let ((c (coroutine x (coroutine-return x))))
  (coroutine-start c 34) )
   34
(letrec ((c1 (coroutine x (coroutine-resume c2 (* 2 x))))
         (c2 (coroutine y (* 3 y))) )
  (coroutine-start c1 5) )
   30
(letrec ((c1 (coroutine x (coroutine-resume c2 (* 2 x))))
         (c2 (coroutine y (coroutine-return (* 3 y)))) )
  (coroutine-start c1 7) )
   42
(letrec ((c1 (coroutine x (coroutine-resume c2 (* 2 x))
                          (coroutine-return 7) ))
         (c2 (coroutine y (coroutine-return (* 3 y)))) )
  (coroutine-start c1 5) )
   7
(letrec ((c1 (coroutine x (coroutine-resume c2 (* 2 x))
                          (coroutine-return 7) ))
         (c2 (coroutine y (coroutine-return (* 3 y)))) )
  (coroutine-start c1 5)
  (coroutine-start c1 13) )
   13
(letrec ((c1 (coroutine x (coroutine-resume c2 (* 2 x))
                          (coroutine-return 7) ))
         (c2 (coroutine y (coroutine-return (* 3 y)))) )
  (coroutine-start c1 5)
  (coroutine-start c2 17) )
   17
(letrec ((c1 (coroutine x (coroutine-resume c2 (* 2 x))
                          (coroutine-resume c2 23) ))
         (c2 (coroutine y (coroutine-return (* 3 y)))) )
  (coroutine-start c1 5) )
   23
(letrec ((c1 (coroutine x (coroutine-resume c2 (* 2 x))))
         (c2 (coroutine y (coroutine-resume c1 (* 3 y)))) )
  (coroutine-start c1 11) )
   66

;(letrec ((c1 (coroutine x (display x)
;                          (display (coroutine-resume c2 2))
;                          (coroutine-return 4) ))
;         (c2 (coroutine y (display y)
;                          (display (coroutine-resume c1 3))
;                          (display (coroutine-resume c1 5))
;                          (coroutine-return 6) )) )
;  (coroutine-start c1 1) )
;   ---

(same-fringe 'a 'a)
   #t
(same-fringe 'a 'b)
   #f
(same-fringe '(a . b) '(a . b))
   #t
(same-fringe '(a . b) '(a . c))
   #f
(same-fringe '(a . b) '(c . b))
   #f
(same-fringe '(a . b) '(c . d))
   #f
(same-fringe '(a . ( b . c)) '((a . b) . c))
   #t
(same-fringe '(a . ( b . (c . d))) '((a . (b . c)) . d))
   #t
(same-fringe '(a . ( b . (e . d))) '((a . (b . c)) . d))
   #f

;;; end of tps.tst
